<template>
	<el-dialog :title="titleMap[mode]" v-model="visible" :width="500" destroy-on-close :close-on-click-modal="false" @closed="$emit('closed')">
		<el-form :model="form" :rules="rules" :disabled="mode=='show'" ref="dialogForm" label-width="100px" label-position="left">
			<el-form-item label="积分额度" prop="amount">
				<el-input v-model="form.amount" placeholder="积分额度" clearable />
			</el-form-item>
			<el-form-item label="用户" prop="member_id">
				<el-input v-model="form.member_id" placeholder="用户" clearable />
			</el-form-item>
			<el-form-item label="积分类型" prop="type">
				<el-select v-model="form.type" placeholder="积分类型" clearable>
					<el-option label="增加" value="income" />
					<el-option label="减少" value="pay" />
				</el-select>
			</el-form-item>
			<el-form-item label="积分描述" prop="remark">
				<el-input type="textarea" v-model="form.remark" placeholder="积分描述" clearable />
			</el-form-item>
		</el-form>
		<template #footer>
			<el-button @click="visible=false" >取 消</el-button>
			<el-button v-if="mode!='show'" type="primary" :loading="isSaveing" @click="submit()">提 交</el-button>
		</template>
	</el-dialog>
</template>

<script>
export default {
	emits: ['success', 'closed'],
	data() {
		return {
			mode: "add",
			titleMap: {
				add: '积分',
				edit: '编辑等级',
				show: '查看'
			},
			visible: false,
			isSaveing: false,
			//表单数据
			form: { title: '', name: ''},
			//验证规则
			rules: {
				amount: [{required: true, message: '请输入积分额度'}],
				member_id: [{required: true, message: '请输入用户UID'}],
				type: [{required: true, message: '请选择积分类型'}],
				remark: [{required: true, message: '请输入积分描述'}]
			}
		}
	},
	mounted() {
	},
	methods: {
		//显示
		open(mode='add'){
			this.mode = mode;
			this.visible = true;
			return this
		},
		//表单提交方法
		submit(){
			this.$refs.dialogForm.validate(async (valid) => {
				if (valid) {
					this.isSaveing = true;
					var res = {};
					if(this.mode == 'add'){
						res = await this.$API.member.score.add.post(this.form);
					}else{
						res = await this.$API.member.score.edit.post(this.form);
					}

					this.isSaveing = false;
					if(res.code == 1){
						this.$emit('success', this.form, this.mode)
						this.visible = false;
						this.$message.success("操作成功")
					}else{
						this.$alert(res.message, "提示", {type: 'error'})
					}
				}else{
					return false;
				}
			})
		},
		//表单注入数据
		setData(data){
			this.form = data
		}
	}
}
</script>
